package diffpatch;

import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.w3c.dom.Node.*;

import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import java.io.*;
import java.util.*;

/** Class DiffDOMDoc provides a ready-made subtree every-time a new
 *  target node is encountered; the sub-tree consists of a "Document" object
 *  and a "root" node <diff> .
 */  
public class DiffDOMDoc {
  Document diffDoc;
  
  public Document getNewDiffDoc() {
    try {
      DocumentBuilderFactory  dbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder db =  dbf.newDocumentBuilder();
      diffDoc  =  db.newDocument();
      Node diffRoot =  diffDoc.createElement("diff");
      diffDoc.appendChild(diffRoot);
    } 
    catch (ParserConfigurationException pce) { 
       pce.printStackTrace();
    }
     return(diffDoc);
  } 

 //Debugging and testing:
  public void printDiffDom() {
   try {
    TransformerFactory tfac = TransformerFactory.newInstance();
    Transformer transformer = tfac.newTransformer();
    transformer.transform(new DOMSource(diffDoc), new StreamResult(System.out));
   System.out.println(System.getProperty("line.separator"));
   }
    catch (TransformerConfigurationException tCfgEx) {
      System.out.println("TransformerConfigurationException: " + tCfgEx.getMessage());
      tCfgEx.printStackTrace();
    }
    catch (TransformerException trEx) {
     System.out.println("TransformException: " + trEx.getMessage());
     trEx.printStackTrace();
    }
  }
  
   public static void printDiffDom(Document doc) {
   try {
    TransformerFactory tfac = TransformerFactory.newInstance();
    Transformer transformer = tfac.newTransformer();
    transformer.transform(new DOMSource(doc), new StreamResult(System.out));
   System.out.println(System.getProperty("line.separator"));
   }
    catch (TransformerConfigurationException tCfgEx) {
      System.out.println("TransformerConfigurationException: " + tCfgEx.getMessage());
      tCfgEx.printStackTrace();
    }
    catch (TransformerException trEx) {
     System.out.println("TransformException: " + trEx.getMessage());
     trEx.printStackTrace();
    }
  }  
} //DiffDOMDoc
