package diffpatch; 

import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.w3c.dom.Node.*;

/** Class DiffNodeInfo stores the context information for the "affected" node 
 */ 
public class DiffNodeInfo {
 String action;
 Node   parent;
 Node   newChild;
 Node   storedNode; //Reference to the node stored in the hash-table. 

 // Attribute  related; null if action is not "attr" related.
 String  attrName;
 String  preValue;
 String  newValue; 

 public static final String  ACTION_REPLACE = "node-replace", 
                             ACTION_INSERT = "node-insert", 
			     ACTION_INSERTBEFORE = "node-insertBefore",
			     ACTION_REMOVE  = "node-remove",
			     ACTION_ATTRADD = "attr-add", 
			     ACTION_ATTRMODIFY = "attr-modify",
			     ACTION_ATTRDELETE = "attr-delete";
			     
 public DiffNodeInfo( String action, Node   parent, Node   newChild,
                      Node storedNode, String  attrName, String  preValue,
                      String  newValue ) { 
    this.action = action;
    this.parent = parent; 
    this.newChild = newChild;
    this.storedNode = storedNode;

    this.attrName = attrName;
    this.preValue = preValue;
    this.newValue = newValue;                      
 
 }

 public DiffNodeInfo( String action, Node   parent, Node   newChild, Node storedNode ) {
   this(action, parent, newChild, storedNode, null, null, null); 
 }

}
