package editor;
import java.awt.*;
import java.util.*;

/** Class CircleShape helps to draw a circle,  but is not 
 *  called from the main class EDitGUI
 */
public class CircleShape extends Shape implements Observer
{
   HotSpot _hsT, _hsB,_hsC;

   int _x, _y, _w;

   public CircleShape(int x, int y, int w)
   {
      _x = x;
      _y = y;
      _w = w;

      _hsT = new HotSpot(new Coordinates(x + w/2, y));
      _hsB = new HotSpot(new Coordinates(x + w/2, y + w));
      _hsC = new HotSpot(new Coordinates(x + w/2, y + w/2),
                         new Dimensions(11, 11));

      _hsT.addObserver(this);
      _hsB.addObserver(this);
      _hsC.addObserver(this);
   }

   public Vector getHotSpots()
   {
      Vector vec = new Vector();

      vec.addElement(_hsT);
      vec.addElement(_hsB);
      vec.addElement(_hsC);

      return vec;
   }

   public void paint(Graphics g)
   {
      int x = _w < 0 ? _x + _w : _x;
      int y = _w < 0 ? _y + _w : _y;
      int w = _w < 0 ? -_w : _w;

      g.drawOval(x, y, w, w);
   }

   public void update(Observable obs, Object obj)
   {
      Coordinates coordT = _hsT.getCoordinates();
      Coordinates coordB = _hsB.getCoordinates();
      Coordinates coordC = _hsC.getCoordinates();

      if (obs == _hsT)
      {
         _y = coordT.y;
         _w = coordB.y - coordT.y;
      }
      else if (obs == _hsB)
      {
         _w = coordB.y - coordT.y;
      }
      else if (obs == _hsC)
      {
         _x = coordC.x - _w/2;
         _y = coordC.y - _w/2;
      }

      _hsT.setCoordinates(new Coordinates(_x + _w/2, _y));
      _hsB.setCoordinates(new Coordinates(_x + _w/2, _y + _w));
      _hsC.setCoordinates(new Coordinates(_x + _w/2, _y + _w/2));
   }
}
