
/* 
  Add the login, send panel;
  Rearrange the panel - Canavas; {pallete,login,send}
*/

package editor; 

import java.awt.*;
import java.util.EventListener.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import diffpatch.*; 

/** The basic code is modified to boot-strap the application as whole;
 *  removed certain deprecated code;
 */
class ShapeActionListener implements ActionListener {
 ShapeMgr shMgr;
  public ShapeActionListener(ShapeMgr sm) {
   shMgr = sm;
  }
  public void actionPerformed(ActionEvent ae) {
   if (ae.getActionCommand().equals("Rectangle") ) {
     shMgr.manage(new RectangleShape(10, 10, 110, 100), false); 
   }
   else if (ae.getActionCommand().equals("Ellipse") ) {
     shMgr.manage(new EllipseShape(10, 10, 150, 100), false); 
   }  
   else if (ae.getActionCommand().equals("Circle") ) {
    shMgr.manage(new CircleShape(10, 10, 100), false);
   }  
   else if (ae.getActionCommand().equals("Line") ) {
     shMgr.manage(new LineShape(10, 10, 100, 100), false);
   }
  }
}

/* class RegListener implements ActionListener {
  JTextField user;
  ShapeMgr shmMgr; 
  String server;
  int appServPort;
 
  public RegListener( ShapeMgr shMgr, String wbServer, 
                     int appservport) { 
   server = wbServer;
   appServPort = appservport;
   shmMgr = shMgr; 

  }

  public void actionPerformed(ActionEvent ae) {
   String userName = user.getText();
   shmMgr.register(server, appServPort);
   System.out.println("The string is " + userName);
  } 
} */

public class EditGUI extends JPanel 
{
   ShapeMgr _sm;
   /* 
      Setting the arguments for the server(WBServer), etc.
      as its done for the WBAppClient   
   */ 

   public void init(String serverName, int appservport)
   {
      setSize( new Dimension(650, 650));   
      setBackground(Color.white);
      setLayout(new BorderLayout());
      _sm = new ShapeMgr();
      /* Bootstrapping the required modules:
         WBAppClient, XMLDiff and WBAppServer thru' WBDOMMAnager 
      */
      _sm.register(serverName, appservport);
   
      add("Center", _sm);

      JPanel p = new JPanel();
      p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));

      JPanel pallete = new JPanel();
      ShapeActionListener shapeListener = 
           new  ShapeActionListener(_sm);  
      SendListener sendListener = 
          new SendListener(_sm);
 
      JButton line, rectangle, ellipse;
   
      line = new JButton("Line");
      rectangle = new JButton("Rectangle");
      ellipse = new JButton("Ellipse");
      pallete.add(line); 
      pallete.add(rectangle);
      pallete.add(ellipse); 
      line.addActionListener(shapeListener);
      rectangle.addActionListener(shapeListener); 
      ellipse.addActionListener(shapeListener);  

      p.add(pallete);
      add("East", p); 
   }
  
   public static void main(String [] args)
   {
      //Taking the command line arguments..
      if (args.length == 2) { 
        String servername = args[0]; 
        int appServPort = Integer.parseInt(args[1]); 
	// wbServPort = Integer.parseInt(args[1]),
        JFrame f = new JFrame("Hot Spot");
        EditGUI m = new EditGUI();
        m.init(servername, appServPort);
        f.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        f.getContentPane().add("Center", m);  
        f.pack();
        f.show();
      }
      else {
          System.out.println("java <wbappserver-name> <appserv-port>");
          System.exit(0);
      }
   }
}
