package sharedboard;

import java.net.*;
import java.io.*;

import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.*;
import org.w3c.dom.*;

/* The basic idea is:
   1) Serialize the Diff-DOM to be sent across the socket.
   2) The Document node of the Diff-DOM is passed to do (1).
   3) No specific protocol is followed - hence the socket is merely closed.
*/   
public class DomSerializer {

   public static void serializeDom(Document source, OutputStream output) {
    DataOutputStream dataout = new DataOutputStream(output);
    try {
    TransformerFactory tfac = TransformerFactory.newInstance();
    Transformer transformer = tfac.newTransformer();
    transformer.transform(new DOMSource(source), new StreamResult(dataout));
    dataout.flush();
    dataout.close(); 
    transformer.transform(new DOMSource(source), new StreamResult(System.out));
    System.out.println(System.getProperty("line.separator"));
   }
   catch (TransformerConfigurationException tCfgEx) {
      System.out.println("TransformerConfigurationException: " + tCfgEx.getMessage());
      tCfgEx.printStackTrace();
   }
   catch (TransformerException trEx) {
     System.out.println("TransformException: " + trEx.getMessage());
     trEx.printStackTrace();
   }
   catch(IOException ioe) {
     ioe.printStackTrace();
   }   
   
  } //serializeDom

}
