package sharedboard; 

import java.net.*;
import java.io.*;
import org.w3c.dom.*;
import org.w3c.dom.Element.*;
import javax.xml.parsers.*;
import java.util.*;


/* The basic idea is: 
   1) First registers with the WB server;
   2) Thereafter sends the data to the WBServerHost; 
   3) Implements the actual WB functionality; 
      - A Simple SVG-like drawing facility..
*/
public class WBAppClient  {
 Socket connection;
 String WBServerHost, userName; 
 int WBServerport, WBAppServerPort;

 public WBAppClient(String server, int WBAppServPort) {
    //Connect to server;
    this.WBServerHost = server;
    this.WBAppServerPort = WBAppServPort;
 } //cons.

 public void registerWithServer(String user) {
   Socket conn = null ; 
   InetAddress inetaddr = null;

   try {
    conn = new Socket(WBServerHost, WBServerport);
    System.out.println("Connected to.." + WBServerHost); 
    inetaddr = conn.getLocalAddress();
   }
   catch (IOException ioe) {
     ioe.printStackTrace();
   }

   long currTime = System.currentTimeMillis();  
   String hostAddr = inetaddr.getHostAddress();

   //Form the DOM  
   Document doc = null; 
   OutputStream out = null;
   try {
     DocumentBuilderFactory fac = DocumentBuilderFactory.newInstance();
     DocumentBuilder builder = fac.newDocumentBuilder();
     doc = builder.newDocument();
   }
   catch (ParserConfigurationException pce) {
     pce.printStackTrace();
   }
   Node session = doc.createElement("session");
   ((Element)session).setAttribute("name", user);
   ((Element)session).setAttribute("currTime", String.valueOf(currTime));
   ((Element)session).setAttribute("hostName", inetaddr.getHostName());
   doc.appendChild(session);

   //Serialize this and send it to server: 
   try {
     out = conn.getOutputStream();  
     DomSerializer.serializeDom(doc, out);   
   }
   catch (IOException ioe) {
    ioe.printStackTrace();
   }
 }//registerWithServer()

 public Socket getNewSocket() {
  Socket connection = null;
  try {
    connection = new Socket(WBServerHost, WBServerport);
  }
  catch (IOException ioe) {
      ioe.printStackTrace();
  }
  return (connection);
 }

 public void delay(int timer) {
  for(int i=0;i < timer * timer; i+=0.5) {
   ;
  }
 }
 public void sendWBMessage(Document doc){
  Socket conn = null;
  /* Connect to the appServer in the peer program rather than the 
     central registration server;  
  */   
  try {
    conn =  new Socket(WBServerHost, WBAppServerPort); //WBServerport);
  } 
  catch (IOException ioe) {
    ioe.printStackTrace();
  }
  
   try {
     OutputStream out = conn.getOutputStream();
     DomSerializer.serializeDom(doc, out); 
   }
   catch (IOException ioe) {
    ioe.printStackTrace();
  }  
 }

} //WBAppClient  
