package sharedboard;

import java.net.*;
import java.io.*;
import org.w3c.dom.*;

import diffpatch.XMLPatch;
import diffpatch.XMLDiff;
import editor.ShapeMgr;


/* The basic idea is:
   1) The server runs in a separate thread;  the XMLPatch is instantiated;
   2) The input stream of bytes is then parsed using the instance of XMLPatch.   
*/   
public class WBAppServer extends Thread {
  ServerSocket servSock = null;
  Socket conn = null;

  XMLPatch  saxPatcher;
  XMLDiff   domDiff; 
  public WBAppServer(int servPort, XMLPatch saxproc) {
   saxPatcher = saxproc;

   try {
     servSock = new ServerSocket(servPort); 
   }
   catch (IOException ioe) {
       ioe.printStackTrace();
   }
  } 
  
  public WBAppServer(int servPort,Document appDoc,
                    ShapeMgr shMgr, XMLDiff xmlDiff) {
   saxPatcher = new XMLPatch(appDoc, shMgr, xmlDiff); 
 
   try {
     servSock = new ServerSocket(servPort);
   }
   catch (IOException ioe) {
       ioe.printStackTrace();
   }
  }
  public void run() {
   InputStream inp = null;
    while (true) { 
      try {
        conn = servSock.accept();  
        System.out.println("Accepted connection from.." + 
                            conn.getInetAddress());
        inp = conn.getInputStream(); 
        processInputStream(inp);
      }
      catch (SocketException soe) {
       soe.printStackTrace();
      }
      catch (IOException ioe) {
       ioe.printStackTrace();
      }
       
      try {
       if ( conn != null ) conn.close();
        inp.close();
      }
      catch (IOException ioe) {
       ioe.printStackTrace();
      } 
    } //while()
    
  }

  public void processInputStream(InputStream input) {

    StringBuffer buff = new StringBuffer();
    String  xmlmsg;
    ByteArrayInputStream byteIn;
    try {
     while(true) {
       int i = input.read();
       if ( i == -1) break;
       buff.append((char)i);
     }
    }
    catch (IOException ioe) {
     ioe.printStackTrace();
    }
    xmlmsg = buff.toString();
    System.out.println("The xml message is " + xmlmsg);
    byte[] xmlBytes = xmlmsg.getBytes();
    byteIn = new ByteArrayInputStream(xmlBytes);

    saxPatcher.beginParsing(byteIn);
  }// processInputStream()

} //eof-class
